#!/usr/bin/env python

#use print('message') instead of print 'message' in python 2.7 as well:
from __future__ import print_function

#import pytest
import os, pprint
from kkrparser_functions import parse_kkr_outputfile
from numpy import mean, std, array, loadtxt


class Test_qdos():
    """
    check results of different features
    """
    def test_12_qdos(self):
        path  = 'test_run12_mpi_1_6/'
        path0 = 'test_run12_mpi_1_6/ref/'
        compare_qdos_files(path, path0)

    def test_12_qdos_SOC(self):
        path  = 'test_run12.1_mpi_1_6/'
        path0 = 'test_run12.1_mpi_1_6/ref/'
        compare_qdos_files(path, path0)
        
# helper functions
def compare_qdos_files(path, path0):
    for fname in 'qdos.01.1.dat qdos.01.2.dat qdos.02.1.dat qdos.02.2.dat qdos.03.1.dat qdos.03.2.dat qdos.04.1.dat qdos.04.2.dat'.split():
       try:
           num = loadtxt(path+fname)
           # remove line with Im(E)
           num = num[:,[0,2,3,4,5,6,7,8,9]]
       except:
           num = loadtxt(path+fname.replace('qdos.', 'qdos.0'))
       try:
           num_ref = loadtxt(path0+fname)
           # remove line with Im(E)
           num_ref = num_ref[:,[0,2,3,4,5,6,7,8,9]]
       except:
           num_ref = loadtxt(path0+fname.replace('qdos.', 'qdos.0'))
       # compare qdos file content
       print(fname)
       print(std(abs(num-num_ref)))
       print(mean(abs(num-num_ref)))
       print(abs(num-num_ref).max())
       assert std(abs(num-num_ref))<5*10**-16
       assert mean(abs(num-num_ref))<10**-14
       assert abs(num-num_ref).max()<2*10**-12
